' ========================================================================================
' GdipAddPathLine2
' ========================================================================================

' SED_PBWIN
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"

%IDC_GRAPHIC  = 101

' ========================================================================================
' The following example draws a star-shaped GraphicsPath.
' ========================================================================================
SUB GDIP_AddPathLine2 (BYVAL hdc AS DWORD)

   LOCAL hStatus AS LONG
   LOCAL pGraphics AS DWORD
   LOCAL pBrush AS DWORD
   LOCAL pPath AS DWORD
   DIM   pt(9) AS POINTL
   DIM   Colors(9) AS DWORD

   hStatus = GdipCreateFromHDC(hdc, pGraphics)

   ' Create a GraphicsPath.
   hStatus = GdipCreatePath(%FillModeAlternate, pPath)

   ' // Fill the array of points.
   pt(0).x = 75  : pt(0).y = 0
   pt(1).x = 100 : pt(1).y = 50
   pt(2).x = 150 : pt(2).y = 50
   pt(3).x = 112 : pt(3).y = 75
   pt(4).x = 150 : pt(4).y = 150
   pt(5).x = 75  : pt(5).y = 100
   pt(6).x = 0   : pt(6).y = 150
   pt(7).x = 37  : pt(7).y = 75
   pt(8).x = 0   : pt(8).y = 50
   pt(9).x = 50  : pt(9).y = 50

   ' Construct the path with the array of points.
   hStatus = GdipAddPathLine2I(pPath, pt(0), 10)

   ' // Use the path to construct a path gradient brush.
   hStatus = GdipCreatePathGradientFromPath(pPath, pBrush)

   ' // Set the color at the center of the path to red.
   hStatus = GdipSetPathGradientCenterColor(pBrush, GDIP_ARGB(255, 255, 0, 0))

   ' // Set the colors of the points in the array.
   Colors(0) = GDIP_ARGB(255, 0, 0, 0)
   Colors(1) = GDIP_ARGB(255, 0, 255, 0)
   Colors(2) = GDIP_ARGB(255, 0, 0, 255)
   Colors(3) = GDIP_ARGB(255, 255, 255, 255)
   Colors(4) = GDIP_ARGB(255, 0, 0, 0)
   Colors(5) = GDIP_ARGB(255, 0, 255, 0)
   Colors(6) = GDIP_ARGB(255, 0, 0, 255)
   Colors(7) = GDIP_ARGB(255, 255, 255, 255)
   Colors(8) = GDIP_ARGB(255, 0, 0, 0)
   Colors(9) = GDIP_ARGB(255, 0, 255, 0)

   hStatus = GdipSetPathGradientSurroundColorsWithCount(pBrush, Colors(0), 9)

   ' // Fill the path with the path gradient brush.
   hStatus = GdipFillPath(pGraphics, pBrush, pPath)

   ' // Cleanup
   IF pPath THEN GdipDeletePath(pPath)
   if pBrush THEN GdipDeleteBrush(pBrush)
   IF pGraphics THEN GdipDeleteGraphics(pGraphics)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hr AS LONG
   LOCAL hDlg AS DWORD
   LOCAL hdc AS DWORD
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   ' Create a new dialog
   DIALOG NEW PIXELS, 0, "GdipAddPathLine2", , , 420, 250, %WS_SYSMENU TO hDlg

   ' Add a graphic control
   CONTROL ADD GRAPHIC, hDlg, %IDC_GRAPHIC,"", 0, 0, 420, 250
   ' Select the drawing target
   GRAPHIC ATTACH hDlg, %IDC_GRAPHIC
   ' Set the foreground and background color
   GRAPHIC COLOR %BLACK, %WHITE
   ' Clear the entire selected graphic window
   GRAPHIC CLEAR
   ' Retrieve the handle of the device context
   GRAPHIC GET DC TO hdc
   ' Draw the graphics
   GDIP_AddPathLine2 hdc

   DIALOG SHOW MODAL hDlg, CALL DlgProc

   ' Shutdown GDI+
   GdiplusShutdown token

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   SELECT CASE CBMSG

      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDCANCEL
               IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL, 0
         END SELECT

   END SELECT

END FUNCTION
' ========================================================================================